JavaScript Data GridSaving data

Save data after each change to the data set, using Handsontable's API hooks. Preserve the table's state by saving data to the local storage.

Save changes using a callback

To track changes made in your data grid, use Handsontable's afterChange hook.

The example below handles data by using fetch. Note that this is just a mockup, and nothing is actually saved. You need to implement the server-side part by yourself.

 
Click "Load" to load data from server
import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

const container = document.querySelector('#example1');
const exampleConsole = document.querySelector('#output');
const autosave = document.querySelector('#autosave');
const load = document.querySelector('#load');
const save = document.querySelector('#save');
const hot = new Handsontable(container, {
  startRows: 8,
  startCols: 6,
  rowHeaders: true,
  colHeaders: true,
  height: 'auto',
  licenseKey: 'non-commercial-and-evaluation',
  afterChange(change, source) {
    if (source === 'loadData') {
      return; // don't save this change
    }

    if (!change) {
      return;
    }

    if (!autosave.checked) {
      return;
    }

    fetch('https://handsontable.com/docs/scripts/json/save.json', {
      method: 'POST',
      mode: 'no-cors',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({ data: change }),
    }).then(() => {
      exampleConsole.innerText = `Autosaved (${change.length} cell${change.length > 1 ? 's' : ''})`;
      console.log('The POST request is only used here for the demo purposes');
    });
  },
  autoWrapRow: true,
  autoWrapCol: true,
});

load.addEventListener('click', () => {
  fetch('https://handsontable.com/docs/scripts/json/load.json').then((response) => {
    response.json().then((data) => {
      hot.loadData(data.data);
      // or, use `updateData()` to replace `data` without resetting states
      exampleConsole.innerText = 'Data loaded';
    });
  });
});
save.addEventListener('click', () => {
  // save all cell's data
  fetch('https://handsontable.com/docs/scripts/json/save.json', {
    method: 'POST',
    mode: 'no-cors',
    headers: {
      'Content-Type': 'application/json',
    },
    body: JSON.stringify({ data: hot.getData() }),
  }).then(() => {
    exampleConsole.innerText = 'Data saved';
    console.log('The POST request is only used here for the demo purposes');
  });
});
autosave.addEventListener('click', () => {
  if (autosave.checked) {
    exampleConsole.innerText = 'Changes will be autosaved';
  } else {
    exampleConsole.innerText = 'Changes will not be autosaved';
  }
});

Save data locally

You can save any type of data in local storage to preserve the table state after page reloads. The persistentState option must be set to true to enable the data storage mechanism. You can set it either during the Handsontable initialization or using the updateSettings() method.

Persistent state storage is particularly useful when running multiple instances of Handsontable on one page as it allows data separation per each instance.

When the persistentState option is enabled, the PersistentState plugin exposes hooks listed below:

PersistentState vs localStorage

The main benefit of using the PersistentState plugin hooks rather than the regular localStorage API is that it ensures separation of data stored by multiple Handsontable instances. For example, if you have two or more instances of Handsontable on one page, data saved by one instance will be inaccessible to the second instance. Those two instances can store data under the same key, and no data would be overwritten.

For the data separation to work properly, make sure that each instance of Handsontable has a unique id.

Angular Data GridSaving data

Save data after each change to the data set, using Handsontable's API hooks. Preserve the table's state by saving data to the local storage.

Save changes using a callback

To track changes made in your data grid, use Handsontable's afterChange hook.

The example below handles data by using fetch. Note that this is just a mockup, and nothing is actually saved. You need to implement the server-side part by yourself.

Click "Load" to load data from server
/* file: app.component.ts */
import {Component, ViewChild, ViewEncapsulation} from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example1-saving-data',
  standalone: false,
  template: ` <div class="example-controls-container">
      <div class="controls">
        <button
          id="load"
          class="button button--primary button--blue"
          (click)="loadClickCallback($event)"
        >
          Load data
        </button>
        <button
          id="save"
          class="button button--primary button--blue"
          (click)="saveClickCallback($event)"
        >
          Save data
        </button>
        <label>
          <input
            type="checkbox"
            name="autosave"
            id="autosave"
            [checked]="isAutoSave"
            (click)="autosaveClickCallback($event)"
          />
          Autosave
        </label>
      </div>
      <output class="console" id="output"> {{ output }} </output>
    </div>
    <div>
      <hot-table [settings]="gridSettings"></hot-table>
    </div>`,
  encapsulation: ViewEncapsulation.None
})
export class Example1SavingDataComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  isAutoSave = false;
  output: string = 'Click "Load" to load data from server';

  readonly gridSettings: GridSettings = {
    startRows: 8,
    startCols: 6,
    rowHeaders: true,
    colHeaders: true,
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true,

    afterChange: (
      change: Handsontable.CellChange[] | null,
      source: Handsontable.ChangeSource
    ) => {
      if (source === 'loadData') {
        return; // don't save this change
      }

      if (!this.isAutoSave) {
        return;
      }

      fetch('https://handsontable.com/docs/scripts/json/save.json', {
        method: 'POST',
        mode: 'no-cors',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify({ data: change }),
      }).then(() => {
        this.output = `Autosaved (${change?.length} cell${
          (change?.length || 0) > 1 ? 's' : ''
        })`;
        console.log('The POST request is only used here for the demo purposes');
      });
    }
  };

  autosaveClickCallback(event: MouseEvent): void {
    const target = event.target as HTMLInputElement;

    this.isAutoSave = target.checked;

    if (target.checked) {
      this.output = 'Changes will be autosaved';
    } else {
      this.output = 'Changes will not be autosaved';
    }
  }

  loadClickCallback(event: MouseEvent): void {
    const hot = this.hotTable?.hotInstance;

    fetch('https://handsontable.com/docs/scripts/json/load.json').then(
      (response) => {
        response.json().then((data) => {
          hot?.loadData(data.data);
          // or, use `updateData()` to replace `data` without resetting states
          this.output = 'Data loaded';
        });
      }
    );
  }

  saveClickCallback(event: MouseEvent): void {
    const hot = this.hotTable?.hotInstance;

    // save all cell's data
    fetch('https://handsontable.com/docs/scripts/json/save.json', {
      method: 'POST',
      mode: 'no-cors',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({ data: hot?.getData() }),
    }).then(() => {
      this.output = 'Data saved';
      console.log('The POST request is only used here for the demo purposes');
    });
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1SavingDataComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1SavingDataComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1SavingDataComponent ]
})

export class AppModule { }

Save data locally

You can save any type of data in local storage to preserve the table state after page reloads. The persistentState option must be set to true to enable the data storage mechanism. You can set it either during the Handsontable initialization or using the updateSettings() method.

Persistent state storage is particularly useful when running multiple instances of Handsontable on one page as it allows data separation per each instance.

When the persistentState option is enabled, the PersistentState plugin exposes hooks listed below:

PersistentState vs localStorage

The main benefit of using the PersistentState plugin hooks rather than the regular localStorage API is that it ensures separation of data stored by multiple Handsontable instances. For example, if you have two or more instances of Handsontable on one page, data saved by one instance will be inaccessible to the second instance. Those two instances can store data under the same key, and no data would be overwritten.

For the data separation to work properly, make sure that each instance of Handsontable has a unique id.

React Data GridSaving data

Save data after each change to the data set, using Handsontable's API hooks. Preserve the table's state by saving data to the local storage.

Save changes using a callback

To track changes made in your data grid, use Handsontable's afterChange hook.

The example below handles data by using fetch. Note that this is just a mockup, and nothing is actually saved. You need to implement the server-side part by yourself.

 
Click "Load" to load data from server
import { useState, useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const [output, setOutput] = useState('Click "Load" to load data from server');
  const [isAutosave, setIsAutosave] = useState(false);
  const autosaveClickCallback = (event) => {
    const target = event.target;

    setIsAutosave(target.checked);

    if (target.checked) {
      setOutput('Changes will be autosaved');
    } else {
      setOutput('Changes will not be autosaved');
    }
  };

  const loadClickCallback = (event) => {
    const hot = hotRef.current?.hotInstance;

    fetch('https://handsontable.com/docs/scripts/json/load.json').then((response) => {
      response.json().then((data) => {
        hot?.loadData(data.data);
        // or, use `updateData()` to replace `data` without resetting states
        setOutput('Data loaded');
      });
    });
  };

  const saveClickCallback = (event) => {
    const hot = hotRef.current?.hotInstance;

    // save all cell's data
    fetch('https://handsontable.com/docs/scripts/json/save.json', {
      method: 'POST',
      mode: 'no-cors',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({ data: hot?.getData() }),
    }).then(() => {
      setOutput('Data saved');
      console.log('The POST request is only used here for the demo purposes');
    });
  };

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <button id="load" className="button button--primary button--blue" onClick={loadClickCallback}>
            Load data
          </button>
          &nbsp;
          <button id="save" className="button button--primary button--blue" onClick={saveClickCallback}>
            Save data
          </button>
          <label>
            <input type="checkbox" name="autosave" id="autosave" checked={isAutosave} onClick={autosaveClickCallback} />
            Autosave
          </label>
        </div>
        <output className="console" id="output">
          {output}
        </output>
      </div>
      <HotTable
        ref={hotRef}
        startRows={8}
        startCols={6}
        rowHeaders={true}
        colHeaders={true}
        height="auto"
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
        afterChange={function (change, source) {
          if (source === 'loadData') {
            return; // don't save this change
          }

          if (!isAutosave) {
            return;
          }

          fetch('https://handsontable.com/docs/scripts/json/save.json', {
            method: 'POST',
            mode: 'no-cors',
            headers: {
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({ data: change }),
          }).then(() => {
            setOutput(`Autosaved (${change?.length} cell${(change?.length || 0) > 1 ? 's' : ''})`);
            console.log('The POST request is only used here for the demo purposes');
          });
        }}
      />
    </>
  );
};

export default ExampleComponent;

Save data locally

You can save any type of data in local storage to preserve the table state after page reloads. The persistentState option must be set to true to enable the data storage mechanism. You can set it either during the Handsontable initialization or using the updateSettings() method.

Persistent state storage is particularly useful when running multiple instances of Handsontable on one page as it allows data separation per each instance.

When the persistentState option is enabled, the PersistentState plugin exposes hooks listed below:

PersistentState vs localStorage

The main benefit of using the PersistentState plugin hooks rather than the regular localStorage API is that it ensures separation of data stored by multiple Handsontable instances. For example, if you have two or more instances of Handsontable on one page, data saved by one instance will be inaccessible to the second instance. Those two instances can store data under the same key, and no data would be overwritten.

For the data separation to work properly, make sure that each instance of Handsontable has a unique id.

Saving data
Save data after each change to the data set, using Handsontable’s API hooks. Preserve the table’s state by saving data to the local storage.
Save changes using a callback
To track changes made in your data grid, use Handsontable’s afterChange hook.
The example below handles data by using fetch. Note that this is just a mockup, and nothing is actually saved. You need to implement the server-side part by yourself.
<script setup lang="ts">import { ref, useTemplateRef } from 'vue';import { HotTable } from '@handsontable/vue3';import { registerAllModules } from 'handsontable/registry';import type { GridSettings } from 'handsontable/settings';import type { CellChange, ChangeSource } from 'handsontable/common';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');const output = ref('Click "Load" to load data from server');const isAutosave = ref(false);
function autosaveClickCallback(event: Event) { const checked = (event.target as HTMLInputElement).checked;
isAutosave.value = checked; output.value = checked ? 'Changes will be autosaved' : 'Changes will not be autosaved';}
function loadClickCallback() { const hot = hotRef.value?.hotInstance;
fetch('/docs/scripts/json/load.json').then((response) => { response.json().then((data: { data: unknown[][] }) => { hot?.loadData(data.data); output.value = 'Data loaded'; }); });}
function saveClickCallback() { const hot = hotRef.value?.hotInstance;
fetch('/docs/scripts/json/save.json', { method: 'POST', mode: 'no-cors', headers: { 'Content-Type': 'application/json' }, body: JSON.stringify({ data: hot?.getData() }), }).then(() => { output.value = 'Data saved'; console.log('The POST request is only used here for the demo purposes'); });}
function afterChange(change: CellChange[] | null, source: ChangeSource) { if (source === 'loadData') { return; }
if (!isAutosave.value) { return; }
fetch('/docs/scripts/json/save.json', { method: 'POST', mode: 'no-cors', headers: { 'Content-Type': 'application/json' }, body: JSON.stringify({ data: change }), }).then(() => { output.value = `Autosaved (${change?.length} cell${(change?.length || 0) > 1 ? 's' : ''})`; console.log('The POST request is only used here for the demo purposes'); });}
const hotSettings = ref<GridSettings>({ startRows: 8, startCols: 6, rowHeaders: true, colHeaders: true, height: 'auto', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation', afterChange,});</script>
<template> <div id="example1"> <div class="example-controls-container"> <div class="controls"> <button id="load" class="button button--primary button--blue" @click="loadClickCallback"> Load data </button> <button id="save" class="button button--primary button--blue" @click="saveClickCallback"> Save data </button> <label> <input type="checkbox" name="autosave" id="autosave" :checked="isAutosave" @click="autosaveClickCallback" /> Autosave </label> </div> <output class="console" id="output">{{ output }}</output> </div> <HotTable ref="hotRef" :settings="hotSettings" /> </div></template>Save data locally
To persist table state (e.g. column order, column widths, row order) across page reloads, use the browser’s localStorage API or sessionStorage in your application. Listen to the appropriate hooks (e.g. afterColumnMove, afterColumnResize) and save or restore state as needed.
Related API reference
Core methods
Hooks
Result
Changes made in the grid are now persisted to your backend or local state on every edit.